local type   = type
local getn   = table.getn
local insert = table.insert
local remove = table.remove


function _G.AddCallback( object, event, callback )
    if object[ event ] == nil then
        object[ event ] = callback
    else
        if type( object[ event ] ) == "table" then
            insert( object[ event ], callback )
        else
            object[ event ] = { object[ event ], callback }
        end
    end
    
    return callback
end

function _G.RemoveCallback( object, event, callback )
    if object[ event ] == callback then
        object[ event ] = nil
    else
        if type( object[ event ] ) == "table" then
            local size = getn( object[ event ] )

            for i = 1, size do
                if object[ event ][ i ] == callback then
                    remove( object[ event ], i )

                    break
                end
            end
        end
    end
end