local type     = type
local pairs    = pairs
local tostring = tostring

local sub  = string.sub
local gsub = string.gsub


function table.save( tbl )
    if type( tbl ) == "number" then
        local text = tostring( tbl )

        return "#" .. gsub( text, ",", "." )
    elseif type( tbl ) == "string" then
        return "$" .. tbl
    elseif type( tbl ) == "table" then
        local new = {}

        for k, v in pairs( tbl ) do
            new[ table.save( k ) ] = table.save( v )
        end

        return new
    else
        return tbl
    end
end


function table.load( tbl )
    if type( tbl ) == "string" then
        local prefix = sub( tbl, 1, 1 )

        if prefix == "$" then
            return sub( tbl, 2 )
        elseif prefix == "#" then
			return loadstring( "return " .. sub( tbl, 2 ) )()
        else
            return tbl
        end
    elseif type( tbl ) == "table" then
        local new = {}

        for k, v in pairs( tbl ) do
            new[ table.load( k ) ] = table.load( v )
        end

        return new
    else
        return tbl
    end
end